"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var browser_fft_recognizer_1 = require("./browser_fft_recognizer");
function create(fftType) {
    if (fftType === 'BROWSER_FFT') {
        return new browser_fft_recognizer_1.BrowserFftSpeechCommandRecognizer();
    }
    else if (fftType === 'SOFT_FFT') {
        throw new Error('SOFT_FFT SpeechCommandRecognizer has not been implemented yet.');
    }
    else {
        throw new Error("Invalid fftType: '" + fftType + "'");
    }
}
exports.create = create;
var browser_fft_recognizer_2 = require("./browser_fft_recognizer");
exports.BACKGROUND_NOISE_TAG = browser_fft_recognizer_2.BACKGROUND_NOISE_TAG;
exports.UNKNOWN_TAG = browser_fft_recognizer_2.UNKNOWN_TAG;
var version_1 = require("./version");
exports.version = version_1.version;
//# sourceMappingURL=index.js.map